"""
Authors: Peter Mawhorter
Consulted: Sohie Lee
Date: 2022-5-1
Purpose: Branching recursing lab practice solutions.
"""


def findMax(numbers):
    """
    Returns the largest number from a list of numbers. Returns None if
    the list is empty.
    """
    if len(numbers) == 0: # No numbers -> result is None
        return None
    elif len(numbers) == 1: # One number -> that's the max
        return numbers[0]
    else:
        # Figure out where the middle of the list is
        midpoint = len(numbers) // 2
        # Get the max of the first half and the max of the last half
        maxFirst = findMax(numbers[:midpoint])
        maxLast = findMax(numbers[midpoint:])
        # If either max is None, we can't compare them; return the other one
        if maxFirst == None:
            return maxLast
        elif maxLast == None:
            return maxFirst
        # If the first max is bigger: return it, otherwise return the second
        elif maxFirst > maxLast:
            return maxFirst
        else:
            return maxLast


print("Results should each be 4:")
print(findMax([4, 2, 1, 3]))
print(findMax([1, 2, 3, 4]))
print(findMax([4, 4, 4, 1]))


def printCoinPossibilities(soFar, numFlips):
    """
    Prints out all possible coin flip results, using 'h' for heads and
    't' for tails. Prints results where the total number of coins is
    equal to numFlips, and only prints results starting with the 'soFar'
    flip results. If the length of soFar is greater than or equal to
    numFlips, just prints soFar.
    """
    # TODO: Implement me


print("Should be just 'hht':")
printCoinPossibilities('hht', 2)
print("Should be 'hhh' and 'hht':")
printCoinPossibilities('hh', 3)
print("Should be 'hh' and 'ht', 'th', and 'tt':")
printCoinPossibilities('', 2)
print("All 8 possibilities for 3 coins:")
printCoinPossibilities('', 3)
